//+------------------------------------------------------------------+
//|                                                   HourFind10.mq4 |
//|                                         Copyright  2011, Vinin. |
//|                                                    vinin@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Vinin."
#property link      "vinin@mail.ru"

extern int WorkHour=20;
extern int CalcDay=30;

static int WorkDay;
static int WorkTime;
double Candle[][4];
double Res[6];

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   WorkDay=TimeDay(iTime(Symbol(), PERIOD_D1,1));
   WorkTime=-1;
   ArrayResize(Candle, CalcDay);

   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {
   if (iBars(Symbol(), PERIOD_D1)<CalcDay+1) return(0);
   if (!NevDay()) return(0);
   CalcCandle();
   if (Res[5]>0) 
      OrderSend(Symbol(), OP_BUY,  0.1, Ask, 15, NormalizeDouble(Ask-Res[2], Digits), NormalizeDouble(Ask+Res[0], Digits), "", 0,0, CLR_NONE);
   else 
      OrderSend(Symbol(), OP_SELL, 0.1, Bid, 15, NormalizeDouble(Bid+Res[2], Digits), NormalizeDouble(Bid-Res[0], Digits), "", 0,0, CLR_NONE);

   

   return(0);
}
//+------------------------------------------------------------------+

bool NevDay(){

   if (WorkDay==Day())     return(false);
   if (WorkHour!=Hour())   return(false);
   if (WorkTime==Time[0])  return(false);
   WorkDay=Day();
   WorkTime=Time[0];
   return(true);
}



void CalcCandle(){
   double _high=0, _low=999999999;
   double _open, _close=iClose(Symbol(),PERIOD_H1,1);
   int j=0;
   for (int i=1;i<=CalcDay*24;i++) {
      _high=MathMax(_high,iHigh(Symbol(),PERIOD_H1,i));
      _low=MathMin(_low,iLow( Symbol(),PERIOD_H1,i));
      int tmpHour=TimeHour(iTime(Symbol(),PERIOD_H1,i));
      if (tmpHour==WorkHour) {
         _open=iOpen(Symbol(),PERIOD_H1,i);
         if (_close>_open) {
            Candle[j][0]=_high-_open;
            Candle[j][1]=_close-_open;
            Candle[j][2]=_open-_low;
            Candle[j][3]=1;
         } else {
            Candle[j][0]=_open-_low;
            Candle[j][1]=_open-_close;
            Candle[j][2]=_high-_open;
            Candle[j][3]=-1;
         }
         _high=0;
         _low=999999999;
         j++;
      }
      if (j>=CalcDay) break;
   }
   double sum1=0, sum2=0, sum3=0, sum4=0;
   for (j=0;j<CalcDay;j++) {
      sum1+=Candle[j][0];
      sum2+=Candle[j][1];
      sum3+=Candle[j][2];
      sum4+=Candle[j][3];
   }
   Res[0]=sum1/CalcDay;
   Res[2]=sum2/CalcDay;
   Res[4]=sum3/CalcDay;
   Res[5]=sum4/CalcDay;
}